/***************************************************************************
*
* Copyright (c) 1989 -- 2000
* by Helsinki University of Technology, Digital Systems Laboratory,
* a.k.a. Laboratory for Theoretical Computer Science.
* All rights reserved.
*
* This software is provided "as is" without express or implied warranty.
*
* Module:  bdd.h
*
* Part of: PROD's programs araprod and "gphgen"
*
* Author:  Kimmo Varpaaniemi
*
* Current version:
*     $Id$
*
* Description:
*     See bdd.c.
*
* Version history:
*     $Log$
***************************************************************************/

typedef struct BDD
{
    unsigned flag;
    unsigned long index;
    struct BDD *low;
    struct BDD *high;
    struct BDD *repres;
} BDD;

extern TOOLS bddTools;
extern LIST *_bddList;
#define BddList() _bddList
#define BddSList() (_bddList = LstCreate(&bddTools))
#define BddDList() LstDestroy(_bddList, TRUE)

DE1(void, BddCat,
    BDD *, bdd)
DE3(BOOL, BddFind,
    BDD *, bdd,
    DATATYPE *, buffer,
    unsigned long *, address)
DE2(void, BalTrBdd,
    BALTREE *, balTree,
    BDD **, bdd)
